commit 7b523f3dff5d7bf49294fe5b794f63cae28d5c5b
Author: Richard Biener <rguenther@suse.de>
Date:   Mon Nov 9 15:19:56 2020 +0100

    tree-optimization/97760 - reduction paths with unhandled live stmt
    
    This makes sure we reject reduction paths with a live stmt that
    is not the last one altering the value.  This is because we do not
    handle this in the epilogue unless there's a scalar epilogue loop.
    
    2020-11-09  Richard Biener  <rguenther@suse.de>
    
            PR tree-optimization/97760
            * tree-vect-loop.c (check_reduction_path): Reject
            reduction paths we do not handle in epilogue generation.
    
            * gcc.dg/vect/pr97760.c: New testcase.
    
    (cherry picked from commit 2686de5617bfb572343933be2883e8274c9735b5)

diff --git a/gcc/testsuite/gcc.dg/vect/pr97760.c b/gcc/testsuite/gcc.dg/vect/pr97760.c
new file mode 100644
index 00000000000..da5ac937a43
--- /dev/null
+++ b/gcc/testsuite/gcc.dg/vect/pr97760.c
@@ -0,0 +1,26 @@
+#include "tree-vect.h"
+
+int b=1;
+static int *g = &b;
+
+void __attribute__((noipa))
+h (unsigned int n)
+{
+  int i = 3;
+  int f = 3;
+  for (; f <= 50; f += 4) {
+    i += 4;
+    *g = i;
+    i += n;
+  }
+}
+
+int main ()
+{
+  check_vect ();
+
+  h (9);
+  if (*g != 150 || b != 150)
+    __builtin_abort ();
+  return 0;
+}
diff --git a/gcc/tree-vect-loop.c b/gcc/tree-vect-loop.c
index 29071630327..64b54873b75 100644
--- a/gcc/tree-vect-loop.c
+++ b/gcc/tree-vect-loop.c
@@ -2975,14 +2975,17 @@ pop:
 	  fail = true;
 	  break;
 	}
-      /* Check there's only a single stmt the op is used on inside
-         of the loop.  */
+      /* Check there's only a single stmt the op is used on.  For the
+	 not value-changing tail and the last stmt allow out-of-loop uses.
+	 ???  We could relax this and handle arbitrary live stmts by
+	 forcing a scalar epilogue for example.  */
       imm_use_iterator imm_iter;
       gimple *op_use_stmt;
       unsigned cnt = 0;
       FOR_EACH_IMM_USE_STMT (op_use_stmt, imm_iter, op)
 	if (!is_gimple_debug (op_use_stmt)
-	    && flow_bb_inside_loop_p (loop, gimple_bb (op_use_stmt)))
+	    && (*code != ERROR_MARK
+		|| flow_bb_inside_loop_p (loop, gimple_bb (op_use_stmt))))
 	  {
 	    /* We want to allow x + x but not x < 1 ? x : 2.  */
 	    if (is_gimple_assign (op_use_stmt)

